import { Assets, Ticker } from 'pixi.js';
import { argTypes, getDefaultArgs } from 'src/stories/utils/argTypes';
import { createScreenInputMap } from 'src/stories/utils/createScreenInputMap';
import MachineContainer from 'src/stories/utils/MachineContainer';
import { centerView } from 'src/stories/utils/resize';
import ReelsSpinSystem from 'src/systems/ReelsSpinSystem';
import { SlotMachineConfig } from 'src/types/SlotMachineConfig';
import { Meta, PixiStory, StoryFn } from '@pixi/storybook-renderer';
import ReelsMachine from '../slotMachines/ReelsMachine';
import MockSystem from "src/systems/MockSystem";

const args = {
    accelerationTime: 1,
    backCoef: 1.1,
    maxSpeed: 40,
    reelStartDelay: 0.2,
    reelStopDelay: 0.5,
    spinningDuration: 2,
    blur: true,
    bounce: true
};

const meta: Meta<typeof ReelsSpinSystem> = {
    title: 'Systems/CelebrateSystem', // Путь для отображения в Storybook
    tags: ['autodocs'], // Включает автоматическую генерацию документации
    parameters: {
        docs: {
            story: {
                height: 600
            },
            description: {
                component: 'Celebrate symbols',
            },
        }
    },
    argTypes: argTypes(args),
    args: getDefaultArgs(args),
};

export default meta;

export const CelebrateSystemStory: StoryFn<typeof args> = (_params, context) => new PixiStory({
    context, init: async (view) =>
    {
        Assets.reset();
        await Assets.init({
            manifest: 'area69/manifest.json',
        });
        await Assets.loadBundle('configs');
        await Assets.loadBundle('symbols');
        const config: SlotMachineConfig = Assets.get('slot_machine_config');
        const machine = new ReelsMachine(config);
        const container = new MachineContainer(machine);
        machine.systems.blockExitState = new MockSystem(machine)
        view.addChild(container);
        context.machine = machine;
        machine.inputs.initMap = createScreenInputMap(config);
        machine.inputs.screenMap = createScreenInputMap(config)
            .map((record, index) => ([0, 1].includes(index) ? { ...record, key: 'A' } : record))
            .map((record, index) => ([5].includes(index) ? { ...record, key: 'A' } : record));
        machine.inputs.celebrateSymbolIndexes = [0, 1, 5];
        machine.inputs.spin = true;
        centerView(view);
    },
    resize: centerView,
    update: () =>
    {
        context.machine && context.machine.update(Ticker.shared.deltaMS);
    }
});
